---
title: KeyframeEffect.setKeyframes()
slug: Web/API/KeyframeEffect/setKeyframes
tags:
  - API
  - Animations
  - Experimental
  - KeyframeEffect
  - Method
  - Reference
  - setKeyframes
  - waapi
  - web animations api
---
<p>{{ SeeCompatTable() }}{{ APIRef("Web Animations API") }}</p>

<p>The <code><strong>setKeyframes()</strong></code> method of the {{domxref("KeyframeEffect")}} interface replaces the keyframes that make up the affected <code>KeyframeEffect</code> with a new set of keyframes.</p>

<h2 id="Syntax">Syntax</h2>

<div class="syntaxbox">
<pre class="brush: js">existingKeyframeEffect.setKeyframes(<em>keyframes</em>);</pre>
</div>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>keyframes</dt>
 <dd><span style="line-height: 1.5;">A keyframe object or </span><code style="font-style: normal; font-weight: normal; line-height: 1.5;">null</code><span style="line-height: 1.5;">. If set to <code>null</code>, the keyframes are replaced with a sequence of empty keyframes.</span><br>
 <br>
 {{Page("/en-US/docs/Web/API/Web_Animations_API/Keyframe_Formats", "Syntax")}}</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>Void.</p>

<h3 id="Exceptions">Exceptions</h3>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Exception</th>
   <th scope="col">Explanation</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>TypeError</code></td>
   <td>One or more of the frames were not of the correct type of object, the keyframes were not <a href="https://w3c.github.io/web-animations/#loosely-sorted-by-offset">loosely sorted by offset</a>, or a keyframe existed with an offset of less than 0 or more than 1.</td>
  </tr>
 </tbody>
</table>

<div class="note">
<p><strong>Note</strong>: If the keyframes cannot be processed or are malformed, the <code>KeyframeEffect</code>'s keyframes are not modified.</p>
</div>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">// passing an array of keyframe objects
existingKeyframeEffect.setKeyframes(
[
  { color: 'blue' },
    { color: 'green', left: '10px' }
  ]
);

// passing an object with arrays for values
existingKeyframeEffect.setKeyframes(
  {
    color: ['blue', 'green'],
    left: [ '0', '10px']
  }
);

// passing a single-member object
existingKeyframeEffect.setKeyframes(
  {
    color: 'blue'
  }
);</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Animations', '#dom-keyframeeffect-setkeyframes', 'KeyframeEffect.setKeyframes()' )}}</td>
   <td>{{Spec2('Web Animations')}}</td>
   <td>Editor's draft.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.KeyframeEffect.setKeyframes")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/KeyframeEffect">KeyframeEffect Interface</a></li>
 <li><a href="/en-US/docs/Web/API/Web_Animations_API">Web Animations API</a></li>
</ul>
